/*
 * i2clcd_2.c
 *
 *  Created on: 15.04.2016
 *      Author: dkassen
 */
#include "i2clcd.h"
#include "i2clcd_2.h"
#include <util/delay.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdint.h>

#include "properties.h"
#include "select.h"

void lcd_printBool(bool status)
{
	if (status)
		lcd_print_P(string_on_en);
	else
		lcd_print_P(string_off_en);
}
bool lcd_printBoolAt(uint8_t line, uint8_t col, bool status)
{
	if (status)
		return lcd_printlc_P(line, col, string_on_en);
	else
		return lcd_printlc_P(line, col, string_off_en);
}
void lcd_printInt(uint16_t value, uint8_t c, bool leadingZeros)
{
	char str[c];
	utoa(value, str, 10);
	if(leadingZeros)
	{
		for( uint8_t i = getDigitCount(value); i < c; i++)
			lcd_print_P(PSTR("0"));
	}
	lcd_print(str);
}

void lcd_clear(bool blinkCurser)
{
	// always set all three parameters  (ON/OFF) when using this command
	if (blinkCurser)
	{
		lcd_command(LCD_DISPLAYON | LCD_CURSORON | LCD_BLINKINGON);
	}
	else
	{
		lcd_command(LCD_DISPLAYON | LCD_CURSOROFF | LCD_BLINKINGOFF);
	}
	lcd_command(LCD_CLEAR);
	_delay_ms(2);
}

void print2Languages(char* first, char* second)
{
	lcd_clear(true);
	lcd_printlc(1, 1, first);
	lcd_printlc(2, 1, second);
}

void printMmSs(uint16_t seconds)
{
	int8_t mm = seconds / 60;
	int8_t ss = seconds % 60;
	lcd_printInt(mm, 2, false);
	lcd_print_P(PSTR(":"));
	lcd_printInt(ss, 2, true);
}
