/*
 * inits.c
 *
 *  Created on: 16.04.2016
 *      Author: dkassen
 */

#include "inits.h"

void ioinit (void)
{
	//Schalter
	DDRD = ~( (1<<PD0) | (1<<PD1)| (1<<PD2) );	/* Eingaenge */
	PORTD|= ( (1<<PD0) | (1<<PD1)| (1<<PD2) );	/* Interne Pull-Up fuer diese einschalten */
	//D3; D4 unbenutzt
	//Lichter
	DDRD =  ( (1<<PD5)| (1<<PD6) | (1<<PD7));	/* Ausgaenge */
	DDRB =  ( (1<<PB0));						/* Ausgaenge */
	//Motorsteuerung
	DDRB =  ( (1<<PB1)| (1<<PB2));				/* Ausgaenge */
	DDRC =  ( (1<<PC1));						/* Ausgaenge */
	DDRC = ~( (1<<PD0) |  (1<<PD2) );			/* Eingaenge */
	PORTC|= ( (1<<PD0) |  (1<<PD2) );			/* Interne Pull-Up fuer diese einschalten */
	//TWI/I2C
	//DDRC =  ( (1<<PC4) |  (1<<PC5));			/* Ausgaenge */

	//Lichter AUS
	PORTD &= ~( (1<<PD5)| (1<<PD6)| (1<<PD7) );
	PORTB &= ~( (1<<PB0) );
	//Motor AUS
	PORTC &= ~( (1<<PC1) );
	PORTB &= ~( (1<<PB1) );
	//timer2_init();
}

void pwm_init()
{
	/*
	Die aus elektrischer Sicht ideale PWM Frequenz liegt daher meist bei 1-2kHz. Allerdings ist dies genau der Bereich,
	in dem das Gehr am empfindlichsten ist. Wenn das Pfeifen des Motors nicht strt, ist dies also der ideale Bereich.
	Da die untere Frequenz durch die elektrische Zeitkonstante des Motors begrenzt ist, kann man nur nach oben ausweichen.
	Ein Kompromiss ist daher der Bereich 5-15kHz in dem das Gehr deutlich unempfindlicher ist, sich die Verluste noch in Grenzen halten.
	Verwendet man die einfache Schaltung mit der Freilaufdiode und legt keinen Wert auf einen runden Lauf,
	bzw. hat eine hohe Masse am Motor, so dass dieser trge ist, dann kann man als Alternative zu den >5kHz die PWM Frequenz
	auch bis auf 200Hz reduzieren um das Gerusch ertrglicher zu machen.
	Allerdings reduziert sich dann der Wirkungsgrad aufgrund des hohen Stromripples.
	*/

	// Timer 0 konfigurieren
	TCCR0B = ((1<<CS00) | (1<<CS01)); // 5=1024; 3=64; 1=1; clk I/O/1024 (from prescaler)

	// Timer 0  Overflow Interrupt erlauben
	TIMSK0 |= (1<<TOIE0);

	// Timer 1 konfigurieren
	//TCCR1B |= (1<<CS11); //Prescaler 8
	TCCR1B |= ((1<<CS10) | (1<<CS12)); //Prescaler 1024

	//Timer 1 Fast PWM Mode, 8 Bit schalten
	TCCR1A |= (1<<WGM10);
	TCCR1B |= (1<<WGM12);

	//Timer 1 Compare Output mode einstellen: Pin geht auf high bei Compare match, auf low bei berlauf.
	//TCCR1A |= (1<<COM1A1) | (1<<COM1B1); //Channel A und B
	TCCR1A |= (1<<COM1B1);//Nur Channel B

	//Beschreieben muss mann dann:
	//OCR1A; OCR1B
}
