/*
 * main.c
 *
 *  Created on: 12.04.2016
 *      Author: dkassen
 */

#include <stdbool.h>
#include <stdint.h>

//#include "main.h"
#include "inits.h"

#include "menu.h"
#include "properties.h"
#include "select.h"
#include "switches.h"
#include "status.h"
#include "display.h"
#include "countdown.h"
#include "adc.h"

//#include "countdown.h" for testing only

//
//void drive_update();

//

//
//void selectLanguage(int8_t upDown);

//
//void runCleaner();
//void runSpinUpDown(int8_t upDown);

int main(void)
{
	ioinit();
	i2c_init();
	lcd_init();
	pwm_init();
	timer2_init();
	//ADC_init();
	// Interrupts (IRQs) global erlauben
	sei();
	// Zeit vertrdeln bis sich die Spannung stabilisiert hat.
	// In die Hauptschleife gehrt 'wait' oder 'delay' nicht rein!
	wait_10ms(1);
	displayWakeUp();
	readOldVariables();
	while (1)
	{
		updateDebouncedSwitches();
		/*if(count.sec.displaySleepAfter == 0 && BacklightSec != 0)//Display schaltet sich ab
		{
			lcd_light(false);
		}*/
		if (count.ms10.menu == 0)
		{
			//print_test();
			menu_update();	//Aktiv nderungen prfen
			count.ms10.menu = 50;
		}

		if (section == RunRun || driveStatus != OFF)
		{
			updateMotorStatus();
			OCR1B = driveAbsolute;
		}
	}
}

uint8_t lcd_dimm = 0;
ISR(TIMER0_OVF_vect)
{
//	LED1 = (count.sec.debounceSW1_3s == 0);
//	LED2 = (count.sec.debounceSW2_3s == 0);
//	LED3 = (count.sec.debounceSW3_3s == 0);
	/*if(driveStatus == OFF)
	{
		LED2 = 1;
		LED1 = 0;
		LED3 = 0;
	}
	else if (driveStatus == SPINUP)
	{
		LED2 = 0;
		LED1 = 1;
		LED3 = 0;
	}
	else if (driveStatus == SPINDOWN)
	{
		LED2 = 0;
		LED1 = 0;
		LED3 = 1;
	}*/
	/*if(!sectionChanged && !valuesChanged)
	{
		if(lcd_dimm == 0)
			lcd_light(true);
		else if(lcd_dimm == 20)
			lcd_light(false);
		if(lcd_dimm > 100)
			lcd_dimm = 0;
		else
			lcd_dimm+= 10;
	}*/
}

void readOldVariables()
{
	uint16_t RPMee = eeprom_read_word(&NonVolatilerRPMmax);
	if(RPMee != 0xFFF)
		RPMmax = RPMee;
	uint8_t VDCee = eeprom_read_byte(&NonVolatilerVDC);
	if(VDCee != 0xFF)
		VDC = VDCee;
	uint8_t DURee = eeprom_read_byte(&NonVolatilerDURATION);
	if(DURee != 0xFF)
		durationM = DURee;
	uint8_t TURNee = eeprom_read_byte(&NonVolatilerTURNTIME);
	if(TURNee != 0xFF)
		turnTimeS = TURNee;
	uint8_t LIGHTee = eeprom_read_byte(&NonVolatilerBacklightSec);
		if(LIGHTee != 0xFF)
			BacklightSec = LIGHTee;
}



////Menuepunkte
//void selectLanguage(int8_t upDown)
//{
//	if(upDown == 0)
//	{
//		if(curserLine == 1)
//		{
//			enum Language next =  menueLang+1;
//			if(next == NANZ) next = NANA+1;
//			print2Languages(LanguageNames[menueLang], LanguageNames[next]);
//		}
//		if(curserLine == 2)
//		{
//			enum Language previous = menueLang-1;
//			if(previous == NANA) previous = NANZ-1;
//			print2Languages(LanguageNames[previous], LanguageNames[menueLang]);
//		}
//
//	}
//	if(upDown > 0)
//	{
//		if(curserLine == 1)
//			selectLanguage(0);//print before increment
//		menueLang = menueLang+1;
//		if(menueLang == NANZ) menueLang = NANA+1;
//		if(curserLine == 2)
//			selectLanguage(0);
//	}
//	if(upDown < 0)
//	{
//		if(curserLine == 2)
//			selectLanguage(0);//print before decrement
//		menueLang = menueLang-1;
//		if(menueLang == NANA) menueLang = NANZ-1;
//		if(curserLine == 1)
//			selectLanguage(0);
//	}
//
//	if(upDown > 0 && curserLine == 1)
//	curserLine = 2;
//	if(upDown < 0 && curserLine == 2)
//	curserLine = 1;
//	lcd_gotolc(curserLine ,LCD_COLS);
//	// always set all three parameters  (ON/OFF) when using this command
//	lcd_command(LCD_DISPLAYON | LCD_CURSORON | LCD_BLINKINGON);
//}
