/*
 * propperties.h
 *
 *  Created on: 15.04.2016
 *      Author: dkassen
 */

#ifndef PROPERTIES_H_
#define PROPERTIES_H_

#include <avr/eeprom.h>

////#define SW1 ((volatile struct test*)&PORTD)->b0
#define SW1 !(PIND & (1<<PD0))
#define SW2 !(PIND & (1<<PD1))
#define SW3 !(PIND & (1<<PD2))

//#define BACKLIGHT ((volatile struct test*)&PORTD)->b5
#define LED1 ((volatile struct test*)&PORTD)->b6
#define LED2 ((volatile struct test*)&PORTD)->b7
#define LED3 ((volatile struct test*)&PORTB)->b0

#define PWM ((volatile struct test*)&PORTB)->b2
#define INA ((volatile struct test*)&PORTC)->b1
#define INB ((volatile struct test*)&PORTB)->b1
//#define ENABLE ((volatile struct test*)&PORTC)->b0
//#define OUTA ((volatile struct test*)&PORTC)->b2
//
//#define SDA ((volatile struct test*)&PORTC)->b4
//#define SCL ((volatile struct test*)&PORTC)->b5
//#define DevHD44780  LCD_I2C_DEVICE //device address of HD44780 over PCF8574A (I2C), see datasheet
/*----------------------------------------------------------*/
#include <stdint.h>

typedef unsigned char byte;
struct test {
	byte b0:1;
	byte b1:1;
	byte b2:1;
	byte b3:1;
	byte b4:1;
	byte b5:1;
	byte b6:1;
	byte b7:1;
} __attribute__((packed));


//enum Language {NANA=0, DEUTSCH, ENGLISH, FRANCE, NANZ};
//const char* LanguageNames[] = { "-", "DEUTSCH", "ENGLISH", "FRANCE", "-"};
//
//enum MenueSection {Welcome=0, ProgOrStart, ProgDuration, ProgTurn, ProgPower, RunRun, RunAbbort};
enum MenueSection {ProgOrStart=0, ProgDuration, ProgTurn, ProgRPM, ProgPower, ProgBacklight, RunRun, RunAbbort};
//
enum MotorStatus {OFF=0, SPINUP, MAX, SPINDOWN};
enum MotorDirection {LINKS=0, RECHTS};

extern uint8_t drivePercent;
extern uint8_t driveAbsolute;

extern uint8_t VDC;
extern uint8_t BacklightSec;
extern uint16_t RPMmax;
extern uint16_t RPMabsolute;
extern uint8_t durationM;
extern uint8_t turnTimeS;
extern uint8_t clockMin;
extern uint8_t clockSec;
extern uint8_t clockSec_turn;
extern uint16_t EEMEM NonVolatilerRPMmax;
extern uint8_t EEMEM NonVolatilerVDC;
extern uint8_t EEMEM NonVolatilerBacklightSec;
extern uint8_t EEMEM NonVolatilerDURATION;
extern uint8_t EEMEM NonVolatilerTURNTIME;

uint8_t getPWMforRPM(uint16_t);
uint16_t getRPMforProz(uint8_t);
uint16_t getRPMforVDC(uint16_t rpm);

extern uint8_t curserLine;
extern uint16_t display_sleep;

#endif /* PROPERTIES_H_ */
