/*
 * select.c
 *
 *  Created on: 15.04.2016
 *      Author: dkassen
 */
#include <util/delay.h>
#include <stdbool.h>
#include <stdint.h>
#include "i2clcd.h"
#include "i2clcd_2.h"
#include "select.h"
#include "properties.h"
#include "status.h"
#include "countdown.h"

#include "switches.h"//only for test
#include "outputs.h"//only for tes

bool sectionChanged = true;
bool valuesChanged = true;
/*void print_Welcome()
{
	lcd_clear(false);
	lcd_print_P(string_welcome_de);
	lcd_printlc_P(2, 2, string_welcome_en);
}*/

/*void print_selectedStart()
{
	lcd_clear(true);
	lcd_printlc_P(1, 1, string_start_de);
	lcd_printlc_P(2, 1, string_config_de);
	lcd_gotolc(curserLine, 15);
	lcd_print_P(PSTR("x"));
	lcd_gotolc(curserLine, 15);
}*/
bool blinkToggle = false;
void print_editMenue()
{
	if (count.ms10.blink == 0)
	{
		blinkToggle = !blinkToggle;
		count.ms10.blink = 100;
	}
	lcd_printlc_P(2, 1, string_empty);
	if(blinkToggle)
		lcd_printlc_P(2, 3, string_editMenu);
}
uint8_t getDigitCount(uint16_t x)
{
	if ( x < 10 )
	  return 1;
	else if ( x < 100 )
	  return 2;
	else if ( x < 1000 )
	  return 3;
	else if ( x < 10000 )
	  return 4;
	return 5;
}

void print_statusInit()
{
	lcd_clear(false);
	lcd_printlc_P(1, 1, string_time_en);
	lcd_printlc_P(1, 14, string_time_min);
	lcd_printlc_P(2, 14, string_time_sec);
}
void print_status(uint8_t m, uint8_t s, uint16_t r, bool blink)
{
	//Minuten schreiben
	uint8_t mc = getDigitCount(m);
	lcd_gotolc(1, 12-mc);
	lcd_printInt(m, mc,false);
	//Sekunden schreiben
	uint8_t sc = getDigitCount(s);
	lcd_gotolc(2, 12-sc);
	lcd_printInt(s, sc, true);
	//RPM schreiben
	uint8_t rc = getDigitCount(r);
	lcd_gotolc(2, 5-rc);
	lcd_printInt(r, rc, false);
	//Richtung schreiben
	lcd_gotolc(2, 7);
	if(!blink || blinkToggle)
	{
		if (driveDirection == LINKS)
			lcd_print_P(PSTR("L"));
		if (driveDirection == RECHTS)
			lcd_print_P(PSTR("R"));
	}else
	{
		lcd_print_P(PSTR(" "));
	}
	if(blink && count.ms10.blink == 0)
	{
		blinkToggle = !blinkToggle;
		count.ms10.blink = 55;
	}
}

void print_selectedStart()//NEW alternate
{
	if(sectionChanged)
	{
		print_statusInit();
		print_status(durationM, turnTimeS, RPMmax, false);
	}
	sectionChanged = false;
}

void print_selectRPM()
{
	if(sectionChanged)
	{
		lcd_clear(false);
		lcd_printlc_P(1, 1, string_rpm_en);
		//lcd_printlc_P(2, 1, string_rpmAll);
		uint8_t rc = getDigitCount(RPMmax);
		lcd_gotolc(1, 12-rc);
		lcd_printInt(RPMmax, rc, false);
	}
	if(valuesChanged || sectionChanged)
	{
		uint8_t rc = getDigitCount(RPMmax);
		uint8_t pos = 1;
		if(RPMmax == 1600)
		{
			pos=1;
		}
		if(RPMmax == 2000)
		{
			pos=6;
		}
		if(RPMmax == 2400)
		{
			pos=11;
		}
		lcd_printlc_P(2, 1, string_empty);
		lcd_printlc_P(2, pos, PSTR("["));
		lcd_printInt(RPMmax, rc, true);
		lcd_print_P(PSTR("]"));
		valuesChanged = false;
	}
	sectionChanged = false;
}

void print_selectedDuration()
{
	if(sectionChanged)
	{
		lcd_clear(false);
		lcd_printlc_P(1, 1, string_time_en);
		lcd_print_P(string_duration_en);
		lcd_printlc_P(1, 14, string_time_min);
	}
	if(valuesChanged || sectionChanged)
	{
		//Minuten schreiben
		uint8_t mc = getDigitCount(durationM);
		lcd_printlc_P(2, 1, string_empty);
		lcd_gotolc(2, 13-mc);
		lcd_printInt(durationM, mc, false);
		valuesChanged = false;
	}
	sectionChanged = false;
}

void print_selectedTurnTime()
{
	if(sectionChanged)
	{
		lcd_clear(false);
		lcd_printlc_P(1, 1, string_time_en);
		lcd_print_P(string_turn);
	}
	if(valuesChanged || sectionChanged)
	{
		lcd_printlc_P(2, 1, string_empty);
		lcd_printlc_P(2, 1, string_time_min);
		lcd_print_P(PSTR(":"));
		lcd_printlc_P(2, 5, string_time_sec);
		lcd_gotolc(2, 13);
		printMmSs(turnTimeS);
		valuesChanged = false;
	}
	sectionChanged = false;
}

void print_selectedVDC()
{
	lcd_clear(true);

	lcd_printlc_P(1, 1, string_VDC_en);
	lcd_gotolc(2, 7);
	lcd_printInt(VDC, 2, false);
}
void print_selectedBackLight()
{
	lcd_clear(true);

	lcd_printlc_P(1, 1, string_Backlight_en);
	if(BacklightSec == 0)
	{
		lcd_printlc_P(1, 11, string_on_en);
		lcd_printlc_P(2, 1, string_empty);
		lcd_printlc_P(2, 3, string_allways_en);
	}
	else
	{
		lcd_printlc_P(1, 11, string_off_en);
		lcd_gotolc(2, 7);
		lcd_printInt(BacklightSec, 3, false);
	}


}

void print_runningCleaner()
{
	if(valuesChanged || sectionChanged)
	{
		print_statusInit();
		print_status(clockMin, clockSec, RPMabsolute, false);
		valuesChanged = false;
	}
	sectionChanged = false;
}

uint16_t preventBetween(uint16_t lower, uint16_t upper, int16_t upDown,
		uint16_t value)
{
	if(upDown == 0)
		return value;
	if (upDown > 0)
	{
		if(value + upDown < value || value + upDown > upper) //+ would overflow, so result is smaller than before
			value = upper;
		else
		{
			value += upDown;
		}
	}else//upDown < 0
	{
		if(value + upDown > value || value + upDown < lower) //- would underflow
			value = lower;
		else
		{
			value += upDown;
		}
	}
	return value;
}

uint8_t rpm2voltFactor = 85;
void print_test()
{
	uint8_t proz = 100;

	uint16_t test0 = getRPMforProz(proz);
	//uint16_t test1 = getRPMforVDC(test0);
	uint16_t test1 = ((uint32_t)test0)*rpm2voltFactor/VDC/20;
	uint8_t test = getPWMforRPM(test1);

	lcd_gotolc(1, 1);
	lcd_printInt(rpm2voltFactor, 3, false);
	lcd_gotolc(1, 5);
	lcd_printInt(test, 3, false);
	lcd_gotolc(2, 1);
	lcd_printInt(VDC, 2, false);
	lcd_gotolc(2, 12);
	lcd_printInt(RPMmax, 4, false);

	OCR1B = test;
	driveStatus = MAX;
	drive_update();
	if(sw1_0sec)
		{
		rpm2voltFactor +=5;
		freeSwitches();
		}
	else if (sw2_0sec)
		{
		rpm2voltFactor -=5;
		freeSwitches();
		}
}
