/*
 * status.c
 *
 *  Created on: 16.04.2016
 *      Author: dkassen
 */

#include "status.h"
#include <stdbool.h>
#include "properties.h"
#include "countdown.h"
#include "i2clcd.h"
#include "i2clcd_2.h"
#include "select.h"
#include "menu.h"
#include "outputs.h"
#include "switches.h"

//Werte (TODO: fr den EPROM spter)
//enum Language menueLang = DEUTSCH;

enum MotorDirection driveDirection = LINKS;
enum MotorStatus driveStatus = OFF;
bool readyForDriveToggle = false;

void toggleDriveDirection()
{
	if (driveDirection == LINKS)
		driveDirection = RECHTS;
	else if (driveDirection == RECHTS)
		driveDirection = LINKS;
	readyForDriveToggle = false;
}
void updateMotorStatus()
{
	if (count.ms10.spin == 0)
	{
		if(section != RunRun)
		{
			driveStatus = SPINDOWN;
		}
		if (driveStatus == SPINUP)
		{
			if(drivePercent == 100)
			{
				driveStatus = MAX;
			}
			drivePercent = preventBetween(0, 100, 20, drivePercent);
		}
		if (driveStatus == SPINDOWN)
		{
			if(drivePercent == 0)
			{
				driveStatus = OFF;
			}
			else
			{
				drivePercent = preventBetween(0, 100, -50, drivePercent);
			}
		}
		RPMabsolute = getRPMforProz(drivePercent);
		uint16_t rpmInclFac = getRPMforVDC(RPMabsolute);
		if(driveStatus == SPINUP)
		{
			driveAbsolute = getPWMforRPM(RPMabsolute);//Harter anlauf, um Granulat in Schwung zu bringen!!
		}else
		{
			driveAbsolute = getPWMforRPM(rpmInclFac);
		}
		count.ms10.spin = 50;
		drive_update();
	}
	//Anzeige
	if(count.ms10.displayAtRun == 0)
	{
		valuesChanged = true;
		count.ms10.displayAtRun = 50;//500ms
	}
	//Ende des Reinigens
	if (clockMin == 0 && clockSec == 0)
	{
		driveStatus = SPINDOWN;
		displayWakeUp();
	}
	else if (readyForDriveToggle)
	{
		if (driveStatus == OFF)
		{
			toggleDriveDirection();
			count.sec.offDelay = 4;
		}
		else
			driveStatus = SPINDOWN;
	}
	else if(driveStatus == OFF && count.sec.offDelay == 0)
	{
		driveStatus = SPINUP;
	}
}

