/*
 * switches.c
 *
 *  Created on: 16.04.2016
 *      Author: dkassen
 */

#include "switches.h"
#include <stdbool.h>
#include "properties.h"
#include "countdown.h"

enum SWSTATUS {RISING_FLANK, HOLDING, FALING_FLANK, RELEASED};
enum SWSTATUS sw1 = RELEASED;
enum SWSTATUS sw2 = RELEASED;
enum SWSTATUS sw3 = RELEASED;
bool sw1_0sec = false;
bool sw2_0sec = false;
bool sw3_0sec = false;
bool sw1_1sec = false;
bool sw2_1sec = false;
bool sw3_1sec = false;
bool sw1_3sec = false;
bool sw2_3sec = false;
bool sw3_3sec = false;
bool sw1_5sec = false;
bool sw2_5sec = false;
bool sw3_5sec = false;

void freeSwitches()
{
	sw1_0sec = false;
	sw2_0sec = false;
	sw3_0sec = false;
	sw1_1sec = false;
	sw2_1sec = false;
	sw3_1sec = false;
	sw1_3sec = false;
	sw2_3sec = false;
	sw3_3sec = false;
	sw1_5sec = false;
	sw2_5sec = false;
	sw3_5sec = false;
}
void sw1Flanking()
{
	if(sw1 == RELEASED && SW1)
	{
		sw1 = RISING_FLANK;
	}
	else if(sw1 == RISING_FLANK && SW1)
	{
		sw1 = HOLDING;
	}
	else if(sw1 == HOLDING && !SW1)
	{
		sw1 = FALING_FLANK;
	}
	else if(sw1 == FALING_FLANK && !SW1)
	{
		sw1 = RELEASED;
	}
}
void sw2Flanking()
{
	if(sw2 == RELEASED && SW2)
	{
		sw2 = RISING_FLANK;
	}
	else if(sw2 == RISING_FLANK && SW2)
	{
		sw2 = HOLDING;
	}
	else if(sw2 == HOLDING && !SW2)
	{
		sw2 = FALING_FLANK;
	}
	else if(sw2 == FALING_FLANK && !SW2)
	{
		sw2 = RELEASED;
	}
}
void sw3Flanking()
{
	if(sw3 == RELEASED && SW3)
	{
		sw3 = RISING_FLANK;
	}
	else if(sw3 == RISING_FLANK && SW3)
	{
		sw3 = HOLDING;
	}
	else if(sw3 == HOLDING && !SW3)
	{
		sw3 = FALING_FLANK;
	}
	else if(sw3 == FALING_FLANK && !SW3)
	{
		sw3 = RELEASED;
	}
}
void updateDebouncedSwitches()
{
	sw1Flanking();
	sw2Flanking();
	sw3Flanking();
	//Signal muss erst beim LOSlassen registriert werden
	if (sw1 == RISING_FLANK)
	{
		count.ms10.debounceSW1_0 = 10;
		count.ms10.debounceSW1_1s = 100;
		count.sec.debounceSW1_3s = 3;
		count.sec.debounceSW1_5s = 5;
	}
	if (sw1 == FALING_FLANK)
	{
		if (count.sec.debounceSW1_5s == 0)
		{
			sw1_5sec = true;
		}
		else if (count.sec.debounceSW1_3s == 0)
		{
			sw1_3sec = true;
		}
		else if (count.ms10.debounceSW1_1s == 0)
		{
			sw1_1sec = true;
		}
		else if(count.ms10.debounceSW1_0 == 0)
		{
			sw1_0sec = true;
		}
	}
	/////////////////////////////////////////
	if (sw2 == RISING_FLANK)
	{
		count.ms10.debounceSW2_0 = 10;
		count.ms10.debounceSW2_1s = 100;
		count.sec.debounceSW2_3s = 3;
		count.sec.debounceSW2_5s = 5;
	}
	if (sw2 == FALING_FLANK)
	{
		if (count.sec.debounceSW2_5s == 0)
		{
			sw2_5sec = true;
		}
		else if (count.sec.debounceSW2_3s == 0)
		{
			sw2_3sec = true;
		}
		else if (count.ms10.debounceSW2_1s == 0)
		{
			sw2_1sec = true;
		}
		else if(count.ms10.debounceSW2_0 == 0)
		{
			sw2_0sec = true;
		}
	}
	/////////////////////////////////////////
	if (sw3 == RISING_FLANK)
	{
		count.ms10.debounceSW3_0 = 10;
		count.ms10.debounceSW3_1s = 100;
		count.sec.debounceSW3_3s = 3;
		count.sec.debounceSW3_5s = 5;
	}
	if (sw3 == FALING_FLANK)
	{
		if (count.sec.debounceSW3_5s == 0)
		{
			sw3_5sec = true;
		}
		else if (count.sec.debounceSW3_3s == 0)
		{
			sw3_3sec = true;
		}
		else if (count.ms10.debounceSW3_1s == 0)
		{
			sw3_1sec = true;
		}
		else if(count.ms10.debounceSW3_0 == 0)
		{
			sw3_0sec = true;
		}
	}
}

